If the app is reaping children by catching SIGCHLD, we need to let that work.
diff -uNr Linux-PAM-0.75/modules/pam_pwdb/support.-c Linux-PAM-0.75/modules/pam_pwdb/support.-c
--- Linux-PAM-0.75/modules/pam_pwdb/support.-c	Sun Feb 11 01:33:53 2001
+++ Linux-PAM-0.75/modules/pam_pwdb/support.-c	Tue Jul 10 00:14:23 2001
@@ -349,6 +349,7 @@
 				  const char *user)
 {
     int retval, child, fds[2];
+    void (*sighandler)(int) = NULL;
 
     D(("called."));
     /* create a pipe for the password */
@@ -357,6 +358,11 @@
 	return PAM_AUTH_ERR;
     }
 
+    /* save the address of the old SIGCHLD handler, because if the calling
+       application set a handler, we need to disable it so that we can reap
+       the helper after it quits */
+    sighandler = signal(SIGCHLD, SIG_DFL);
+
     /* fork */
     child = fork();
     if (child == 0) {
@@ -396,6 +402,9 @@
 	D(("fork failed"));
 	retval = PAM_AUTH_ERR;
     }
+    if(sighandler != NULL) {
+        signal(SIGCHLD, sighandler);   /* restore the signal handler */
+    }
 
     D(("returning %d", retval));
     return retval;
diff -uNr Linux-PAM-0.75/modules/pam_unix/support.c Linux-PAM-0.75/modules/pam_unix/support.c
--- Linux-PAM-0.75/modules/pam_unix/support.c	Sun Feb 11 01:33:53 2001
+++ Linux-PAM-0.75/modules/pam_unix/support.c	Tue Jul 10 00:14:23 2001
@@ -398,6 +398,7 @@
 				   unsigned int ctrl, const char *user)
 {
     int retval, child, fds[2];
+    void (*sighandler)(int) = NULL;
 
     D(("called."));
     /* create a pipe for the password */
@@ -406,6 +407,11 @@
 	return PAM_AUTH_ERR;
     }
 
+    /* save the address of the old SIGCHLD handler, because if the calling
+       application set a handler, we need to disable it so that we can reap
+       the helper after it quits */
+    sighandler = signal(SIGCHLD, SIG_DFL);
+
     /* fork */
     child = fork();
     if (child == 0) {
@@ -449,6 +455,9 @@
 	D(("fork failed"));
 	retval = PAM_AUTH_ERR;
     }
+    if(sighandler != NULL) {
+        signal(SIGCHLD, sighandler);	/* restore the signal handler */
+    }
 
     D(("returning %d", retval));
     return retval;
